
#ifndef CRITTER_H
#define CRITTER_H

#include <fstream.h>
#include "prob.h"
#include "net.h"

class critter
{
public:

	enum {movecosts=10,turncosts=10,eatcosts=30};

	enum {initialfood=(movecosts*4+turncosts+eatcosts)*20};
	net brain;

	//senses/input= 	up dn lt rt hunger
	//reactions/output=	up dn lt rt eat!

	critter();
	~critter()  { };


	int food,age;

	int x,y;

	prob outup,outdn,outlt,outrt,outeat;

	int modfood(int=0);

	cgbbool nofood() { return cgbbool(food<=0); }


	void senses(prob,prob,prob,prob,prob);
	void react(prob&,prob&,prob&,prob&,prob&);
	void react() { react(outup,outdn,outlt,outrt,outeat);}

	void mutate(prob=1,prob=100.0); //mutate(chance,howmuch)

	void suppress(prob=6);			//suppress wates
	
	void dump();
    cgbbool save(ofstream&);
    cgbbool load(ifstream&);

};


#endif
//end of this file


