//chris busch
//replacement for slow floating pt

#ifndef FASTFLOAT_H	   
#define FASTFLOAT_H

class Fastfloat
{
  // private:
public:
  int n;
public:
  enum {places=8};

  Fastfloat() {};
  Fastfloat(int a) { (*this)=a; }
  Fastfloat(double a) { (*this)=a; }
  Fastfloat(float a) { (*this)=a; }
  
  Fastfloat convert(int a)
    {
      Fastfloat dum;
      dum.n=a;
      return dum;
    }

  Fastfloat operator = (Fastfloat a)    {      return convert(n=a.n);    }
  Fastfloat operator = (int a)    {
      return convert(n=(a<<places));
    }
  Fastfloat operator = (double a)    {
	return convert(n=(int)(a*(1<<places)));
  }
  Fastfloat operator = (float a)    {
	return convert(n=(int)(a*(1<<places)));
  }
  Fastfloat operator + (Fastfloat a)    {      return convert(n+a.n);    }
  Fastfloat operator - (Fastfloat a)    {      return convert(n-a.n);    }
  Fastfloat operator * (Fastfloat a)
    {
      return 
		convert( 
				((unsigned int)(abs(n)*(unsigned int)abs(a.n))>>places) 
				*  (1 - ( ((n<0)^(a.n<0)) << 1)));
	  //		* (((n<0)!=(a.n<0)) ? -1 : 1));
    }
  Fastfloat operator / (Fastfloat a)
    {
      return convert(
					 (unsigned int)(abs(n)<<places)/abs(a.n) 
					 *  (1 - ( ((n<0)^(a.n<0)) << 1)));
	  //		     *   (((n<0)!=(a.n<0)) ? -1 : 1));
    }
  operator int()    {      return n>>places;    }
  operator float()    {      return n/(float)(1<<places);    }
  operator double()    {      return n/(double)(1<<places);    }

  int operator == (Fastfloat a)    {      return n == a.n;    }
  int operator != (Fastfloat a)    {      return n != a.n;    }
  int operator > (Fastfloat a)    {      return n > a.n;    }
  int operator < (Fastfloat a)    {      return n < a.n;    }
  int operator >= (Fastfloat a)    {      return n >= a.n;    }
  int operator <= (Fastfloat a)    {      return n <= a.n;    }
};

#endif
//this file